VERSION 5.00
Begin VB.Form Form1 
   Caption         =   "Form1"
   ClientHeight    =   3195
   ClientLeft      =   60
   ClientTop       =   345
   ClientWidth     =   4680
   LinkTopic       =   "Form1"
   ScaleHeight     =   3195
   ScaleWidth      =   4680
   StartUpPosition =   3  'Windows Default
   Begin VB.CommandButton cmdPrintVbStyle 
      Caption         =   "Print VB Style"
      Height          =   525
      Left            =   960
      TabIndex        =   1
      Top             =   1560
      Width           =   2655
   End
   Begin VB.CommandButton cmdPrint 
      Caption         =   "Print Rounded Rectangle"
      Height          =   525
      Left            =   960
      TabIndex        =   0
      Top             =   600
      Width           =   2655
   End
End
Attribute VB_Name = "Form1"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

Private Type DOCINFO
        cbSize As Long
        lpszDocName As String
        lpszOutput As String
End Type

Private Type PRINTER_DEFAULTS
        pDatatype As String
        pDevMode As Long
        DesiredAccess As Long
End Type

Private Type POINTAPI
     x As Long
     y As Long
End Type

Private Type LOGPEN
     lopnStyle As Long
     lopnWidth As POINTAPI
     lopnColor As Long
End Type

Private Declare Function OpenPrinter Lib "winspool.drv" Alias "OpenPrinterA" (ByVal pPrinterName As String, phPrinter As Long, pDefault As PRINTER_DEFAULTS) As Long
Private Declare Function CreateDCBynum Lib "gdi32" Alias "CreateDCA" (ByVal lpDriverName As String, ByVal lpDeviceName As String, ByVal lpOutput As String, ByVal lpInitData As Long) As Long
Private Declare Function CreatePenIndirect Lib "gdi32" (lpLogPen As LOGPEN) As Long
Private Declare Function RoundRect Lib "gdi32" (ByVal hdc As Long, ByVal x1 As Long, ByVal y1 As Long, ByVal x2 As Long, ByVal y2 As Long, ByVal x3 As Long, ByVal y3 As Long) As Long
Private Declare Function SelectObject Lib "gdi32" (ByVal hdc As Long, ByVal nObject As Long) As Long
Private Declare Function DeleteObject Lib "gdi32" (ByVal hObject As Long) As Long
Private Declare Function StartDoc Lib "gdi32" Alias "StartDocA" (ByVal hdc As Long, lpdi As DOCINFO) As Long
Private Declare Function StartPage Lib "gdi32" (ByVal hdc As Long) As Long
Private Declare Function EndPage Lib "gdi32" (ByVal hdc As Long) As Long
Private Declare Function EndDocAPI Lib "gdi32" Alias "EndDoc" (ByVal hdc As Long) As Long
Private Declare Function DeleteDC Lib "gdi32" (ByVal hdc As Long) As Long

Private Sub cmdPrint_Click()
Dim DeviceName As String
Dim dinfo As DOCINFO
Dim lp As LOGPEN
Dim pdefs As PRINTER_DEFAULTS
Dim docname As String
Dim ret As Long
Dim prhdc As Long
    
' variables for our pen and rounded rectangle
Dim hndPen As Long
Dim oldPen As Long
Dim x1 As Long, y1 As Long, x2 As Long, y2 As Long, x3 As Long, y3 As Long

' Constants
Const PS_SOLID = 0
Const PRINTER_ACCESS_ADMINISTER = &H4
Const PRINTER_ACCESS_USE = &H8
    
    ' Get the current printer
    DeviceName = Printer.DeviceName     ' "HP LaserJet III"

    ' Set printer defaults
    pdefs.pDatatype = vbNullString
    pdefs.pDevMode = 0
    pdefs.DesiredAccess = PRINTER_ACCESS_ADMINISTER Or PRINTER_ACCESS_USE

    ' open the printer
    ret = OpenPrinter(DeviceName, prhdc, pdefs)

    ' get a hdc
    prhdc = CreateDCBynum("WINSPOOL", DeviceName$, vbNullString, 0)
    If prhdc = 0 Then GoTo cleanup

    ' The DOCINFO structure is the information that the
    ' print manager will show.
    docname$ = "Rounded Rectangle"
    dinfo.cbSize = Len(dinfo)
    dinfo.lpszDocName = docname$
    dinfo.lpszOutput = vbNullString

    ' Begin the printing process
    ret = StartDoc(prhdc, dinfo)
    ret = StartPage(prhdc)
   
    ' values for our pen
    Dim pnt As POINTAPI
    pnt.x = 12                       ' change this value to adjust Pen Width
    lp.lopnColor = vbBlack
    lp.lopnStyle = PS_SOLID
    lp.lopnWidth = pnt

    ' create Pen object
    hndPen = CreatePenIndirect(lp)

    ' select our pen object for our printer DC
    oldPen = SelectObject(prhdc, hndPen)

    ' Values for our rounded rectangle in twips - modify to change rectangle size and
                                            ' rounded corners
    ' upper left point      ' TwipsPerPixel X & Y provide device resolution independence
    x1 = 720 / Printer.TwipsPerPixelX   ' 0.5 inch
    y1 = 720 / Printer.TwipsPerPixelY   ' 0.5 inch
    ' lower right point
    x2 = 10800 / Printer.TwipsPerPixelX ' 7.5 inch
    y2 = 14400 / Printer.TwipsPerPixelY ' 10 inch
    ' rounded corners
    x3 = 720 / Printer.TwipsPerPixelX   ' 0.5 inch      ' width of ellipse for rounded corners
    y3 = 720 / Printer.TwipsPerPixelY   ' 0.5 inch      ' height of ellipse for rounded corners

    ' Print our Rounded Rectangle
    ret = RoundRect(prhdc, x1, y1, x2, y2, x3, y3)
    ' Remove our pen
    ret = DeleteObject(hndPen)

    'End Page and doc
    ret = EndPage(prhdc)
    If ret >= 0 Then ret = EndDocAPI(prhdc)

cleanup:
    If prhdc <> 0 Then ret = DeleteDC(prhdc)
End Sub

Private Sub cmdPrintVbStyle_Click()
Dim x1 As Long, y1 As Long, x2 As Long, y2 As Long, x3 As Long, y3 As Long

    ' Print something to initialize the printer.
    Printer.CurrentX = 1440
    Printer.CurrentY = 1440
    Printer.Print " "

    ' Upper left corner.
    x1 = 1440 / Printer.TwipsPerPixelX          ' 1 inch
    y1 = 1440 / Printer.TwipsPerPixelY          ' 1 inch
    ' Lower right corner.
    x2 = 5 * 1440 / Printer.TwipsPerPixelX      ' 5 inches
    y2 = 3 * 1440 / Printer.TwipsPerPixelY      ' 3 inches
    ' Width and height of the corner ellipse.
    x3 = 1440 / Printer.TwipsPerPixelX          ' 1 inch
    y3 = 0.5 * 1440 / Printer.TwipsPerPixelY    ' 0.5 inch

    ' Draw the rounded rectangle.
    RoundRect Printer.hdc, x1, y1, x2, y2, x3, y3

    Printer.EndDoc
End Sub


